/*
 * Copyright 2012 ssg.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ssg.tools.easyconfig.data.types;

import ssg.tools.easyconfig.data.NSetting;
import ssg.tools.easyconfig.data.NValidationException;

/**
 *
 * @author ssg
 */
public abstract class BaseSettingType implements ISettingType {

    int size = 20;

    public BaseSettingType() {
    }

    public BaseSettingType(int size) {
        this.size = size;
    }

    public int getSize() {
        return size;
    }

    public void testMandatory(NSetting ns, String value) throws NValidationException {
        if (value == null || value.isEmpty()) {
            if (ns != null && ns.isMandatory()) {
                throw new NValidationException("Mandatory value for '" + ns.getName() + "' is missing.");
            }
        }
    }
}
