/*
 * Copyright 2012 ssg.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ssg.tools.easyconfig.models;

import ssg.tools.easyconfig.data.NSetting;
import ssg.tools.easyconfig.data.NSettingSource;
import ssg.tools.easyconfig.data.handler.IConfigurationHandler;
import ssg.tools.easyconfig.data.handler.TemplateConfigurationHandler;

/**
 *
 * @author ssg
 */
public class ConfigurationChangeEvent {
    private Object source;
    private TemplateConfigurationHandler changedTemplate;
    private IConfigurationHandler changedSource;
    private IConfigurationHandler changedTarget;
    private NSettingSource changedSettingSource;
    private NSetting changedSetting;

    public ConfigurationChangeEvent(Object source, TemplateConfigurationHandler changedTemplate, IConfigurationHandler changedSource, IConfigurationHandler changedTarget) {
        this.source = source;
        this.changedTemplate = changedTemplate;
        this.changedSource = changedSource;
        this.changedTarget = changedTarget;
    }

    public ConfigurationChangeEvent(Object source, NSettingSource changedSettingSource, NSetting changedSetting) {
        this.source = source;
        this.changedSettingSource = changedSettingSource;
        this.changedSetting = changedSetting;
    }

    /**
     * @return the source
     */
    public Object getSource() {
        return source;
    }

    /**
     * @return the changedTemplate
     */
    public TemplateConfigurationHandler getChangedTemplate() {
        return changedTemplate;
    }

    /**
     * @return the changedSource
     */
    public IConfigurationHandler getChangedSource() {
        return changedSource;
    }

    /**
     * @return the changedTarget
     */
    public IConfigurationHandler getChangedTarget() {
        return changedTarget;
    }

    /**
     * @return the changedSettingSource
     */
    public NSettingSource getChangedSettingSource() {
        return changedSettingSource;
    }

    /**
     * @return the changedSetting
     */
    public NSetting getChangedSetting() {
        return changedSetting;
    }

}
