/*
 * Copyright 2012 ssg.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ssg.tools.easyconfig.utils;

import java.util.ArrayList;

/**
 *
 * @author ssg
 */
public class Ring<T> extends ArrayList<T> {

    int idx = 0;

    public T next() {
        if (isEmpty()) {
            return null;
        }
        if (idx >= size()) {
            idx = 0;
        }
        return get(idx++);
    }

    public T peek() {
        if (isEmpty()) {
            return null;
        }
        int ref = idx;
        if (ref >= size()) {
            ref = 0;
        }
        return get(ref);
    }
}
