/*
 * Copyright 2012 ssg.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ssg.tools.easyconfig.vc;

import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.util.Vector;
import javax.swing.JComponent;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.table.TableColumnModel;
import javax.swing.table.TableModel;

/**
 *
 * @author ssg
 */
public class CreativeTable extends JTable {

    public CreativeTable() {
        System.out.println("Creative table is created...");
        init();
    }

    public CreativeTable(TableModel dm) {
        super(dm);
        init();
    }

    public CreativeTable(TableModel dm, TableColumnModel cm) {
        super(dm, cm);
        init();
    }

    public CreativeTable(TableModel dm, TableColumnModel cm, ListSelectionModel sm) {
        super(dm, cm, sm);
        init();
    }

    public CreativeTable(int numRows, int numColumns) {
        super(numRows, numColumns);
        init();
    }

    public CreativeTable(Vector rowData, Vector columnNames) {
        super(rowData, columnNames);
        init();
    }

    public CreativeTable(Object[][] rowData, Object[] columnNames) {
        super(rowData, columnNames);
        init();
    }

    void init() {
        this.setOpaque(false);
//        this.setOpaque(false);
        ((JComponent) getDefaultRenderer(Object.class)).setOpaque(false);
    }
    
    @Override
    protected void paintComponent(Graphics g) {
//        Graphics2D g2 = (Graphics2D) g.create();
//        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
//                RenderingHints.VALUE_ANTIALIAS_ON);
//        GradientPaint gp = new GradientPaint(0, 0,
//                getBackground().brighter().brighter(), 0, getHeight(),
//                getBackground().darker().darker());
//        g2.setPaint(gp);
//        g2.fillRect(0, 0, getWidth(), getHeight());
//        g2.drawString("Creative table", 10, getHeight() / 2 + 20 / 2);
        super.paintComponent(g);
    }
}
