/*
 * Copyright 2012 ssg.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ssg.tools.easyconfig.vc.behaviours;

import ssg.tools.easyconfig.models.ConfigurationTreeModel;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.JTree;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;

/**
 *
 * @author ssg
 */
public class ChangeConfigModeTreeMouseListener implements MouseListener {

    public void mouseClicked(MouseEvent e) {
        if (e.isShiftDown() && e.getButton() == MouseEvent.BUTTON1) {
            JTree tree = (JTree) e.getSource();
            TreePath tp = tree.getPathForLocation(e.getX(), e.getY());
            if (tp.getPathCount() == 1) {
                // handle shift+click for root
                TreeModel tm = tree.getModel();
                if (tm instanceof ConfigurationTreeModel) {
                    ((ConfigurationTreeModel) tm).switchMode(ConfigurationTreeModel.MODE_UNKNOWN);
                }
                tm.getRoot();
                tree.setSelectionInterval(0, 0);
            }
        }
    }

    public void mousePressed(MouseEvent e) {
    }

    public void mouseReleased(MouseEvent e) {
    }

    public void mouseEntered(MouseEvent e) {
    }

    public void mouseExited(MouseEvent e) {
    }
}
